<template lang="pug">
  div.jvl-setup
    div.ui.stackable.container.centered
      h1 Setup
      p.subtitle How to get your very own Javelin running.
    div.ui.segment.inverted.container
      div.ui.segment.inverted
        h2 Requirements
        div.ui.segment.inverted.stacked
          p
          | #[strong.highlight Warning!] This setup guide assumes you have some knowledge about running servers,
          | compiling source code, managing the same, and understanding bandwidth limitations and server outputs.
          | #[strong.highlight This setup requires a savvy system administrator].
          ul.ui.list
            li.item #[i.podcast.icon] OBS
            li.item #[i.box.icon] Cargo or #[i.docker.icon] Docker
            li.item #[i.server.icon] High-Bandwidth Server
            li.item #[i.beer.icon] Beer
        h2 Installing and Running
        div.ui.segment.inverted.stacked
          h3 #[i.box.icon] Cargo
          p Cargo is Rust's compiler helper tool, which can also be used to quickly install Crates.
          div.ui.segment.inverted.stacked.code
            p cargo install javelin
            p #[span.comment # Make sure your $CARGO_HOME/bin is in your $PATH]
            p javelin #[span.param --permit-stream-key=]#[span.string "mysecretstreamkey"]
          h3 #[i.docker.icon] Docker
          p
          | Docker is a virtualization layer that allows for the creation of isolated services and easy management.
          | You can find the image on the docker hub #[a.highlight.underlined(href="https://hub.docker.com/r/valeth/javelin") here].
          div.ui.segment.inverted.stacked.code
            p docker pull registry.gitlab.com/valeth/javelin:latest
            p docker run #[span.param --tty] #[span.param  -p] 1935:1935 #[span.escape \]
            p #[span.indent] registry.gitlab.com/valeth/javelin:latest #[span.escape \]
            p #[span.indent] #[span.param --hls-root=]/tmp/streamout #[span.escape \]
            p #[span.indent] #[span.param --permit-stream-key=]123456
        h2 Broadcasting
        div.ui.segment.inverted.stacked
          h3 #[i.podcast.icon] Open Broadcaster Software (OBS Studio)
          p
          | Make sure you set up OBS adequately for your network bandwidth.
          | Don't forget that you still need to send video and audio data to the server.
          | And that the server then needs to send that same data to whoever is watching.
          p
          | Go into #[span.highlight File > Settings > Stream].
          | Set #[span.highlight Service] to #[span.highlight Custom...]
          | In the #[span.highlight Server] field enter your server location in the form of
          | #[span.highlight rtmp://host:port/app] where #[span.highlight host] is the server domain or IP.
          | You can omit the #[span.highlight port] if you are using the default #[span.highlight 1935]
          | and the #[span.highlight app] is arbitrary and can be whatever you choose.
          | The #[span.highlight Stream Key] is the same one you permitted in the installation above.
          div.ui.padding
          div.ui.centered
            a(href="https://i.imgur.com/x2FwK6S.png" target="_blank")
              img.ui.image.rounded(src="https://i.imgur.com/x2FwK6S.png")
        h2 Watching
        div.ui.segment.inverted.stacked
          h3 #[i.film.icon] Media Player Classic
          p
          | Going into #[span.highlight File > Open File...] will open a source dialogue.
          | In the #[span.highlight Open:] field enter either the same addres you entered in the
          | #[span.highlight Server] field in OBS, or the #[span.highlight .m3u8] playlist URL if you
          | are exporting the files over an HTTP server in the HLS format.
          | The HLS url, depending on your setup, is usually at #[span.highlight http(s)://host:port/app/playlist.m3u8]
          div.ui.padding
          div.ui.centered
            a(href="https://i.imgur.com/0zUO4ZO.png" target="_blank")
              img.ui.image.rounded(src="https://i.imgur.com/0zUO4ZO.png")
        div.ui.segment.inverted.stacked
          h3 #[i.video.file.icon] VLC Media Player
          p
          | Going into #[span.highlight Media > Open Network Stream...] will open a source dialogue.
          | In the #[span.highlight Please enter a network URL:] field enter either the same addres you entered in the
          | #[span.highlight Server] field in OBS, or the #[span.highlight .m3u8] playlist URL if you
          | are exporting the files over an HTTP server in the HLS format.
          | The HLS url, depending on your setup, is usually at #[span.highlight http(s)://host:port/app/playlist.m3u8]
          div.ui.padding
          div.ui.centered
            a(href="https://i.imgur.com/S5PtcEH.png" target="_blank")
              img.ui.image.rounded(src="https://i.imgur.com/S5PtcEH.png")
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator'

@Component
export default class JavelinSetup extends Vue {
}
</script>

<style lang="stylus" scoped>
accent = #95375b

img.ui.image
  display: unset
  margin: 0 auto

.highlight
  color: accent
  &.underlined
    text-decoration: underline;

.fake.link
  cursor: pointer

.ui.three.column.stackable.grid > .five.wide.column
  width: 30.9% !important

.ui.inverted.segment.code
  line-height: 0.5em
  border: 1px solid accent
  overflow-x: scroll
  overflow-y: hidden
  white-space: nowrap
  & .comment
    color: #969896
  & .param
    color: #8abeb7
  & .string
    color: #b5bd68
  & .escape
    color: #de935f
  & .indent
    padding-left: 2rem
</style>
